
/*******************************************************************************
 
 NTS: seems to work with proximity too - so far I seem to only be able to get maybe duration?
 
 
 This sketch is based on Random_Touch_MP3.ino from Bare Conductive which uses code by Jim Lindblom 
 and plenty of inspiration from the Freescale Semiconductor datasheets and application notes.
 Bare Conductive code written by Stefan Dzisiewski-Smith and Peter Krige. 
 This work is licensed under a MIT license https://opensource.org/licenses/MIT
 Copyright (c) 2016, Bare Conductive
 
*******************************************************************************/

// compiler error handling
#include "Compiler_Errors.h"

#include <Adafruit_NeoPixel.h>
#include <math.h>

#define NUMPIXELS 26  // Number of pixels in strand
#define NEOP_PIN A2  // NeoPixel LED strand is connected to this pin
Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUMPIXELS, NEOP_PIN, NEO_GRB + NEO_KHZ800);


// touch includes
#include <MPR121.h>
#include <Wire.h>
#define MPR121_ADDR 0x5C
#define MPR121_INT 4


// define LED_BUILTIN for older versions of Arduino
#ifndef LED_BUILTIN
#define LED_BUILTIN 13
#endif

//time
unsigned long timeAtLEDon = 0;
//long LEDonInterval = 1000.0*60.0*10.0; //1000 milliseconds (1 sec) * seconds in a minute * number of minutes
float LEDonInterval = 4000.0;
boolean isOn = false;

//button
int buttonPushCounter = 0;   // counter for the number of button presses
int buttonState = 0;         // current state of the button
int lastButtonState = 0;     // previous state of the button

void setup(){  

  
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
  
  //Serial.begin(57600);
   Serial.begin(9600);
  
  pinMode(LED_BUILTIN, OUTPUT);

  // initialise the Arduino pseudo-random number generator with 
  // a bit of noise for extra randomness - this is good general practice
  randomSeed(analogRead(0));

  if(!MPR121.begin(MPR121_ADDR)) Serial.println("error setting up MPR121");
  MPR121.setInterruptPin(MPR121_INT);
 
   
}

void loop(){
  //do a quick LED test to show that LEDs work and sketch has been reset
  //made it 3000 so I can get a nice group start up animation
 if (millis() < 3000) {
  colorWipe(strip.Color(255, 255, 255), 30); //white
  colorWipe(strip.Color(0, 0, 0), 30);
  }

  readTouchInputs();
  
strip.show();

}


void readTouchInputs(){
  if(MPR121.touchStatusChanged()){
    
    MPR121.updateTouchData();

    // action if we have four or fewer pins touched
    // do not ignore multiple touches
    
    if(MPR121.getNumTouches()<=4){
      for (int i=0; i < 12; i++){  // Check which electrodes were pressed
        if(MPR121.isNewTouch(i)){        
            //pin i was just touched
            Serial.print("pin ");
            Serial.print(i);
            Serial.println(" was just touched");
            digitalWrite(LED_BUILTIN, HIGH);
            } else {
          if(MPR121.isNewRelease(i)){
            Serial.print("pin ");
            Serial.print(i);
            Serial.println(" is no longer being touched");
            digitalWrite(LED_BUILTIN, LOW);
          } 
        }
      }
    }
    

   if (MPR121.isNewTouch(9)) {
   buttonState = HIGH;
    }

    if (MPR121.isNewRelease(9)) {
   buttonState = LOW;
    }

    if (buttonState != lastButtonState) {
    if (buttonState == HIGH) {
      buttonPushCounter++;
      // Serial.println("on");
      Serial.print("number of button pushes: ");
      Serial.println(buttonPushCounter);
    }  
  }
if (buttonPushCounter >= 5 && MPR121.isNewTouch(1)) {
    for (int i = 0; i <= strip.numPixels() - 1; i++) {
      strip.setPixelColor(i, 255, 255, 255);
    }
  }

   if (buttonPushCounter >= 10) {
    buttonPushCounter = 0;
    for (int i = 0; i <= strip.numPixels() - 1; i++) {
      strip.setPixelColor(i, 0, 0, 0);   
    }
  }

    if (!isOn) {
    if (buttonPushCounter >= 5 && MPR121.isNewTouch(1)) {
      timeAtLEDon = millis();
      isOn = true;
      }
    }
  

  if (millis() > LEDonInterval + timeAtLEDon) {
    for (int i = 0; i <= strip.numPixels() - 1; i++) {
      strip.setPixelColor(i, 0, 0, 0);
     isOn = false;
    }
  }
  
  }
}
 


  // Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for (uint16_t i = 0; i < strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
}
 
